# -*- coding:utf-8 -*-
"""
    SDK client
"""
import threading
#import bos related module
from baidubce import exception
from baidubce.services import bos
from baidubce.services.bos.bos_client import BosClient
from baidubce.bce_client_configuration import BceClientConfiguration
from baidubce.auth.bce_credentials import BceCredentials
from baidubce.protocol import HTTPS

from bosftp_config import BosftpCfg

class Client(object):
    _instance_lock = threading.Lock()

    @classmethod
    def __new__(cls, *args, **kwargs):
        if not hasattr(Client, "_instance"):
            with Client._instance_lock:
                if not hasattr(Client, "_instance"):
                    Client._instance = object.__new__(cls)
                    config = BceClientConfiguration(
                        credentials = BceCredentials(
                            access_key_id = BosftpCfg().ak,
                            secret_access_key = BosftpCfg().sk 
                        ),
                        endpoint = BosftpCfg().host,
                        protocol = HTTPS
                    )
                    if config.connection_timeout_in_mills > 0:
                        config.connection_timeout_in_mills = BosftpCfg().connection_timeout_in_mills
                    Client._instance.bos_client = BosClient(config)
        return Client._instance
           
if __name__ == "__main__":
    c = Client()
    x = Client()
    print Client().bos_client
    print c
    print x
